/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package graphicslab;

import java.awt.Graphics2D;
import java.util.Random;
/**
 *
 * @author Kenrick
 */
public class Drawable {
    // Location on the screen of the object to draw
    protected int x, y;   
    
    // by default we will add deltaX and deltaY to the item's X/Y coordinates each time time.
    // If positive, this moves the object down and to the right.
    // If negative, this moves the object up and to the left.   
    // If this number is changed the object moves farther every time tick.
    protected int deltaX = 2, deltaY = 2;     
    
    // Random number generator
    private Random rnd = new Random();
    
    public Drawable()
    {
        // Picks a random start location
        x = rnd.nextInt(GraphicsLab.WIDTH);
        y = rnd.nextInt(GraphicsLab.HEIGHT);
    }
    
    // Override this method to paint something else
    public void paint(Graphics2D g)
    {
        // Default is to draw a rectangle at X/Y
        g.fillRect(x, y, 4, 4);
    }
    
    // Override this method to change how the update is done
    public void update()
    {
      x += deltaX;
      y += deltaY;
      
      // Check if we hit the edge of the screen and if we did
      // move it back so it fits and then change the direction
      if (x >= GraphicsLab.WIDTH)
      {
          x -= deltaX; 
          // deltaX is positive, so make it negative
          deltaX *= -1;
      }
      else if (x < 0)
      {
          deltaX *= -1;    // deltaX is negative, so make it positive
          x += deltaX;    // add it in so we are not off the edge
      }
      if (y >= GraphicsLab.HEIGHT)
      {
          y -= deltaY;  // Same for the Y directions
          deltaY *= -1;     
      }
      else if (y < 0)
      {
          deltaY *= -1;
          y += deltaY;         
      }      
    }
}
