/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package graphicslab;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import javax.swing.JPanel;
import javax.swing.Timer;
import java.awt.event.ActionEvent;      // For timer
import java.awt.event.ActionListener;   // For timer

/**
 *
 * @author Kenrick
 */
public class GraphicsPanel extends JPanel implements ActionListener
{
    private Timer timer;  
    private Drawable[] sprites;     // Array of drawable objects
        
    public GraphicsPanel()
    {
        this.setDoubleBuffered(true); // Helps prevent flickering
        this.setBackground(Color.WHITE);
        
        // Assign our drawable objects
        sprites = new Drawable[3];
        sprites[0] = new Drawable();
        sprites[1] = new SoccerBall();
        sprites[2] = new SolidBall();

        // Animation Timer; it goes off every 5 milliseconds
        // Change the number below for a different timer interval
        // In this case, every 5 millisceoncds the "actionPerformed"
        // method is called
        timer = new Timer(5, this);        
        timer.start();               
    }
        
    // Draws any Drawable objects on the graphics panel
    public void paint(Graphics g)
    {
        super.paint(g);
        Graphics2D g2d = (Graphics2D) g;

        // Draw every sprite 
        for (Drawable s : sprites)
        {
            s.paint(g2d);
        }        

        // This is just cleanup stuff
        Toolkit.getDefaultToolkit().sync();
        g.dispose();
    }          
        
    public void actionPerformed(ActionEvent e)
    {
        // Update every Drawable object
        for (Drawable s : sprites)
        {
            s.update();
        }
        repaint();
    }
 
}
